/***********************************************************************************/
// Lit le caractre sur la liaison srie et recopie sur l'cran lcd
/***********************************************************************************/
#include <p18cxxx.h>
#define  USE_AND_MASKS
#include <pconfig.h>	// choix des fonctions en fonction du type de pic
#include <delays.h>
#include <stdio.h>
#include <timers.h>		// Timers
#include <usart.h>		// RS232
#include <portb.h>		// Interruptions Externes
#include "HardwareProfile.h"					
#pragma config OSC = INTIO67	// horloge interne
//#pragma config OSC = HS		// horloge externe
#pragma config WDT=OFF			// whatch dog
/***********************************************************************************************/
#define RS PORTCbits.RC0
#define RW PORTCbits.RC1
#define E PORTCbits.RC2
#define led1 PORTCbits.RC3
/***********************************************************************************************/
unsigned char car;			// caractre reu sur rs232
unsigned char mem;			// memeoire caractre
unsigned char i;			// index de position du caractre sur la ligne
void comand(unsigned char com);
// Procedure de traitement des IT hautes (int ext0)
#pragma interrupt HiISR
void HiISR(void)
{
	if (INTCONbits.INT0IF==1)		// IT sur INT0 ?
	{
		
		if (PORTBbits.RB0==0)		// un premier niveau de filtrage, le BP doit encore tre  1
		{							// anti-rebond
			Delay10us(100);
			if (PORTBbits.RB0==0)	// un seconde niveau de filtrage, le BP doit toujours tre  1
			{
				car=0x01;comand(car); // efface l'cran lcd
				i=0;
			}
		}
		
		INTCONbits.INT0IF=0;		// Acquitement de l'INT0
	}

}

// Mise ne place du vecteur d'IT priorit haute
#pragma code highVector=0x08
	void HiVector(void){_asm goto HiISR _endasm}
#pragma code

/*****************************************************************************************/
void Setup(void)
{
	TRISC=0;			// Port C en Sortie
	TRISA=0;			// Port A en Sortie
	OSCCON=0x70;		// 0 111 00 0 00pas de prdiviseur => 8MHz horloge interne
	ADCON1=0x0f;		// Tout digital
	led1=0;			
	// Initialisation de la liaison srie  9600b
	OpenUSART( 	USART_TX_INT_OFF  &
            	USART_RX_INT_OFF  &
            	USART_ASYNCH_MODE &		// mode asynchrone
            	USART_EIGHT_BIT   &		// 8bits
            	USART_CONT_RX     &
            	//USART_BRGH_HIGH,71);  // [(11059200/9600)/16]-1 si hrl ext
				USART_BRGH_HIGH,51);  	// [(8000000/9600)/16]-1	si hrl int 8MHz	

	// Validation de l'interruption INT0 sur front descendant
	OpenRB0INT( PORTB_CHANGE_INT_ON &	// valide l'interruption sur RB0 
				FALLING_EDGE_INT    & 	// front descendant
				PORTB_PULLUPS_ON    );
	// Absolument necesaire pour un traitement des interruptions 
	RCONbits.IPEN=1;
	INTCONbits.GIEH = 1;				// IT Haute autorise
	
}									

/*******************************************************************************************/
//      Fonction criture d'une commande dans l'afficheur
/*******************************************************************************************/
void comand(unsigned char com)
{
	RS=0;
	RW=0;
	E=1;
	Delay10TCYx(100);
	PORTA=com;
	Delay10TCYx(100);
	E=0;
	RS=1;
	RW=1;
}
/*******************************************************************************************/
//      Fonction criture d'une donne dans l'afficheur
/*******************************************************************************************/
void donnee(unsigned char data)
{
	RS=1;
	RW=0;
	E=1;
	Delay10TCYx(100);
	PORTA=data;
	Delay10TCYx(100);
	E=0;
	RS=1;
	RW=1;
}
/*******************************************************************************************/
void main(void)
{
	
	Setup();					// Initialisation
	puts(" PIC16F2420 ");		// Prompt sur rs232
	printf("\r\n");

	// Initialisation de l'afficheur
	Delay100TCYx(250);
	car=0x38;					// 	Mode 8bits 2 lignes			
	comand(car);

    car=0x0c;					//  Display ON Cursor OFF  Blink OFF				
	comand(car);

	car=0x01;					//  Clear display cursor home		
	comand(car);

	car=0x06;					// Increment No shift		
	comand(car);
	
	car=0x52;					// RS232 >
	donnee(car);
	car=0x53;
	donnee(car);
	car=0x32;
	donnee(car);
	car=0x33;
	donnee(car);
	car=0x32;
	donnee(car);
	car=0x20;
	donnee(car);
	car=0x3e;
	donnee(car);
	
	car=0xc0;					// cursor 40h	
	comand(car);
	
	car=0x39;					// 9600b/s
	donnee(car);
	car=0x36;
	donnee(car);
	car=0x30;
	donnee(car);
	car=0x30;
	donnee(car);
	car=0x62;
	donnee(car);
	car=0x2F;
	donnee(car);
	car=0x73;
	donnee(car);

	car=0x02;					// cursor home		
	comand(car);
/*******************************************************************************************/
	i=0;
	for(;;)
	{
		/***********************************************************************************/
		// Lit le caractre sur la liaison srie et recopie sur l'cran lcd
		/***********************************************************************************/
  		led1=0;
		while (!DataRdyUSART());
		car=ReadUSART();  
		led1=1;
		mem=car;
		if (car!=0x0d) donnee(car);
		i=i+1;
		if (i==8) {car=0xc0 ;comand(car);}
		if (i>16) {car=0x01;comand(car);Delay100TCYx(15);donnee(mem);i=1;}
		if (mem==0x0d) {car=0x2;comand(car);i=0;}
	}
	/***********************************************************************************/
}
