/******************************************************/
// Lecture des caractres mis par le module RFID UM005
/******************************************************/
#include <p18cxxx.h>
#define  USE_AND_MASKS
#include <pconfig.h>	// choix des fonctions en fonction du type de pic
#include <delays.h>
#include <stdio.h>
#include <timers.h>		// Timers
#include <usart.h>		// RS232
#include "HardwareProfile.h"					
#pragma config OSC = INTIO67	// horloge interne
#pragma config WDT=OFF			// whatch dog
/***********************************************************************************************/
#define led1 PORTCbits.RC0
#define led2 PORTCbits.RC1
#define led3 PORTCbits.RC2
#define code1 PORTCbits.RC3
#define code2 PORTCbits.RC4
#define code3 PORTCbits.RC5
#define code4 PORTAbits.RA0
#define code5 PORTAbits.RA1
#define code6 PORTAbits.RA2
#define code7 PORTAbits.RA3
#define code8 PORTAbits.RA4
#define code9 PORTAbits.RA5
#define code10 PORTAbits.RA6
#define code11 PORTAbits.RA7

/***********************************************************************************************/
// Procedure de traitement des IT hautes (int timer0)
#pragma interrupt HiISR
void HiISR(void)
{
	if (INTCONbits.TMR0IF==1)		// Si overflow du timer0
	{
		led1=0;led2=0;led3=0;
		code1=1;code2=1;code3=1;
		code4=1;code5=1;code6=1;
		code7=1;code8=1;code9=1;
		code10=1;code11=1;
		INTCONbits.TMR0IF=0;
		CloseTimer0();
	}
 }

// Mise ne place du vecteur d'IT priorit haute
#pragma code highVector=0x08
	void HiVector(void){_asm goto HiISR _endasm}
#pragma code
/*****************************************************************************************/
void Setup(void)
{
	TRISC=0;			// Port C en Sortie
	TRISA=0;			// Port A en Sortie
	ADCON1=0x0F;		// Tout PortA en digital
	OSCCON=0x70;		// 0 111 00 0 00pas de prdiviseur => 8MHz horloge interne
	
	// Initialisation de la liaison srie  9600b
	OpenUSART( 	USART_TX_INT_OFF  &
            	USART_RX_INT_OFF  &
            	USART_ASYNCH_MODE &		// mode asynchrone
            	USART_EIGHT_BIT   &		// 8bits
            	USART_CONT_RX     &
				USART_BRGH_HIGH,51);  	// [(8000000/9600)/16]-1	si hrl int 8MHz	

	// Initialisation interruptions

	INTCON2bits.TMR0IP=1;				// Timer0 High Priority Overflow Interrupt
	INTCONbits.TMR0IF=0;				// Timer0 Interrupt Flag

	RCONbits.IPEN=1;					// Interrupt Priority Enable bit
	INTCONbits.GIEH = 1;				// IT Haute autorise
}									
/*******************************************************************************************/
/*  Fonction interruption timer0 --> N ms	8388ms maxi									   */
/*******************************************************************************************/
void timer0N(unsigned int ms)
{
	unsigned int NBtimer;
	if (ms>8388) ms=8388;
	NBtimer = (65535 - (ms/256)*2000);
	OpenTimer0( TIMER_INT_ON  &			// Int Timer0 Enable
                T0_16BIT      &			// Mode 16bits
                T0_SOURCE_INT &			// HRL Interne Fosc/4
                T0_PS_1_256 );			// Prescalire 256 => Fosc/4/256/65535 = 8,4s
	WriteTimer0( NBtimer );				
}
/*******************************************************************************************/
unsigned char tab[20];
unsigned char i;						
void main(void)
{
	Setup();
	led1=1;led2=1;led3=1;
	code1=1;code2=1;code3=1;
	code4=1;code5=1;code6=1;
	code7=1;code8=1;code9=1;
	code10=1;code11=1;	
	
	//puts("<PIC16F2420>");				// Prompt sur rs232
	//printf("\r\n");						// RC LF
	led1=0;led2=0;led3=0;
	/*********************************************************************************************************/
	// lecture des caractres reus sur la liaison srie
	/*********************************************************************************************************/
	do
	{
		do
		{
			do
			{
				while (!DataRdyUSART());				// Is data available in the read buffer?
				tab[0]=ReadUSART();						// 1er caractere
			} 
			while (tab[0]!=0x01);						// attend 1er caractre gal 01
	
			while (!DataRdyUSART());					// 2eme caractre = longueur de la trame
			tab[1]=ReadUSART();

		}
		while (!((tab[1]==0x0b) || (tab[1]==0x0f)));	// attend la longueur de la trame = 0B ou 0F
														// longueur = 0F pour la trame version
														// longueur = 0B pour une trame JTAG

		for (i=2;i<tab[1];i++)							// enregistre le reste de la trame
		{
			while (!DataRdyUSART());	
			tab[i]=ReadUSART();		
		}
		printf("\r\n");						// RC LF
		for (i=3;i<8;i++)
		{     
			printf("%02x",tab[i]);				// envoi des 11 caractres reus sur la liaison srie
			Delay100TCYx(10);					// ralentit la transmission rs232
		}
		printf("\r\n");						// RC LF
	
/***********************************************************************************************************/
//    Dcodage ID  des TAGs permet l'identification de 3 tags pr-programms VIERZON et codage sur 2bits
//    Puis lance le timer0 qui efface les leds et repositionne  1 les bits code au bout de 5s
/***********************************************************************************************************/
		if (tab[3]==0x01 & tab[4]==0x08  & tab[5]==0x28  & tab[6]==0x41 & tab[7]==0xb0) 
		{led1=1;code1=0;timer0N(2000);}		
		if (tab[3]==0x01 & tab[4]==0x05  & tab[5]==0xab  & tab[6]==0x70 & tab[7]==0xfa)
		{led2=1;code1=0;timer0N(2000);}
		if (tab[3]==0x01 & tab[4]==0x05  & tab[5]==0xac  & tab[6]==0xb4 & tab[7]==0xde)
		{led3=1;code1=0;timer0N(2000);}
/**********************************************************************************************************/
//    Dcodage ID  d'un TAG perso => 3leds ON
		if (tab[3]==0x01 & tab[4]==0x06  & tab[5]==0x41  & tab[6]==0x3c & tab[7]==0xb6) 
		{led1=1;led2=1;led3=1;code1=0;timer0N(2000);}	
/**********************************************************************************************************/
	}
	while (1);
}
